
			macro	ildir
			ld	(.ildi),a
			xor	a
			cp	c
			adc	b
			ld	b,a
.ldiloop		ld	a,(hl) : inc hl
			ld	(de),a : inc de
			dec	c
			jp	nz,.ldiloop
			dec	b
			jp	nz,.ldiloop
			ld	a,0
.ildi   		equ	$-1
			endm

;--------------------------------------------------------------------- ----- ---- --- -- - -  -   -     -
depack:
			ld	bc, $ffff               ; preserve default offset 1
			push	bc
			inc	bc
			ld	a, $80
dzx0s_literals:
			call	dzx0s_elias             ; obtain length

			ildir				; copy literals

			add     a, a                    ; copy from last offset or new offset?
			jp      c, dzx0s_new_offset
			call    dzx0s_elias             ; obtain length
dzx0s_copy:
			ex      (sp), hl                ; preserve source, restore offset
			push    hl                      ; preserve offset
			add     hl, de                  ; calculate destination - offset

		        ildir                            ; copy from offset

			pop     hl                      ; restore offset
			ex      (sp), hl                ; preserve offset, restore source
			add     a, a                    ; copy from literals or new offset?
			jp      nc, dzx0s_literals
dzx0s_new_offset:
			call    dzx0s_elias             ; obtain offset MSB
			ld	(dzx0_offbackup),a
			pop     af                      ; discard last offset
			xor     a                       ; adjust for negative offset
			sub     c
			ret     z                       ; check end marker
			rra
			ld      b,a                     ; last offset bit becomes first length bit
			ld      a, (hl)                 ; obtain offset LSB
			inc     hl
			rra
			ld      c,a
			ld	a,#3e
dzx0_offbackup		equ $-1
			push    bc                      ; preserve new offset
			ld      bc, 1                   ; obtain length
			call    nc, dzx0s_elias_backtrack
			inc     bc
			jp      dzx0s_copy
dzx0s_elias:
			inc     c                       ; interlaced Elias gamma coding
dzx0s_elias_loop:
			add     a, a
			jp      nz, dzx0s_elias_skip
			ld      a, (hl)                 ; load another group of 8 bits
			inc     hl
			rla
dzx0s_elias_skip:
			ret     c
dzx0s_elias_backtrack:
			add     a, a
			ld	(dzx0_elibackup),a
			ld	a,c
			rla
			ld      c,a
			ld	a,b
			rla
			ld      b,a
			ld	a,#3e
dzx0_elibackup		equ $-1
			jp      dzx0s_elias_loop
